Index: issm/trunk/src/c/shared/Numerics/IsInputConverged.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/IsInputConverged.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Numerics/IsInputConverged.cpp	(revision 13395)
@@ -12,5 +12,5 @@
 #endif
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 void IsInputConverged(IssmDouble* peps, Input** new_inputs,Input** old_inputs,int num_inputs,int criterion_enum){
@@ -53,5 +53,5 @@
 		else eps=0;
 	}
-	else _error2_("convergence criterion " << EnumToStringx(criterion_enum) << " not supported yet!");
+	else _error_("convergence criterion " << EnumToStringx(criterion_enum) << " not supported yet!");
 
 	/*Assign output pointers:*/
Index: issm/trunk/src/c/shared/Numerics/OptimalSearch.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/OptimalSearch.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Numerics/OptimalSearch.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 
 #include "./numerics.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../io/io.h"
 #include "../../include/include.h"
@@ -41,5 +41,5 @@
 	//get the value of the function at the first boundary
 	fx1= (*f)(x1,optargs);
-	if (xIsNan<IssmDouble>(fx1)) _error2_("Function evaluation returned NaN");
+	if (xIsNan<IssmDouble>(fx1)) _error_("Function evaluation returned NaN");
 	cout<<setprecision(5);
 	if(VerboseControl()) _pprintLine_("");
@@ -57,5 +57,5 @@
 		iter++;
 		fx2 = (*f)(x2,optargs);
-		if (xIsNan<IssmDouble>(fx2)) _error2_("Function evaluation returned NaN");
+		if (xIsNan<IssmDouble>(fx2)) _error_("Function evaluation returned NaN");
 		if(VerboseControl())
 		 _pprintLine_("         "<<setw(5)<<iter<<"    "<<setw(12)<<x2<<"  "<<setw(12)<<fx2<<"  "<<(fabs(x2-x1)>fabs(fx2-fx1)?fabs(fx2-fx1):fabs(x2-x1)));
Index: issm/trunk/src/c/shared/Numerics/OptionsFromAnalysis.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/OptionsFromAnalysis.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Numerics/OptionsFromAnalysis.cpp	(revision 13395)
@@ -11,5 +11,5 @@
 #include <cstring>
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Parameters.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
@@ -57,5 +57,5 @@
 	if (found==-1){
 		/*ok, we did not find anything, this is not good! error out: */
-		_error2_("could find neither a default analysis  nor analysis " << EnumToStringx(analysis_type));
+		_error_("could find neither a default analysis  nor analysis " << EnumToStringx(analysis_type));
 	}
 
Index: issm/trunk/src/c/shared/Numerics/PetscOptionsFromAnalysis.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/PetscOptionsFromAnalysis.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Numerics/PetscOptionsFromAnalysis.cpp	(revision 13395)
@@ -9,5 +9,5 @@
 #endif
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Parameters.h"
 #include "../../toolkits/toolkits.h"
Index: issm/trunk/src/c/shared/Numerics/UnitConversion.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/UnitConversion.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Numerics/UnitConversion.cpp	(revision 13395)
@@ -11,5 +11,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
 #include "../../shared/shared.h"
@@ -29,5 +29,5 @@
 	if(direction_enum==IuToExtEnum) for(i=0;i<numvalues;i++)values[i]=values[i]*scale; 
 	else if(direction_enum==ExtToIuEnum) for(i=0;i<numvalues;i++)values[i]=values[i]/scale; 
-	else _error2_("wrong direction for unit conversion, either IuToExtEnum or ExtToIuEnum. ");
+	else _error_("wrong direction for unit conversion, either IuToExtEnum or ExtToIuEnum. ");
 
 }
@@ -51,27 +51,28 @@
 		case TimesteppingTimeStepEnum:               scale=1.0/yts;break; //yr
 		case TimeEnum:                               scale=1.0/yts;break; //yr
-		case HydrologyWaterVxEnum:                   scale=yts;break; //m/yr
-		case HydrologyWaterVyEnum:                   scale=yts;break; //m/yr
-		case VxEnum:                                 scale=yts;break; //m/yr
-		case InversionVxObsEnum:                     scale=yts;break; //m/yr
-		case VyEnum:                                 scale=yts;break; //m/yr
-		case InversionVyObsEnum:                     scale=yts;break; //m/yr
-		case VzEnum:                                 scale=yts;break; //m/yr
-		case InversionVzObsEnum:                     scale=yts;break; //m/yr
-		case VelEnum:                                scale=yts;break; //m/yr
-		case InversionVelObsEnum:                    scale=yts;break; //m/yr
-		case BalancethicknessThickeningRateEnum:     scale=yts;break; //m/yr
-		case BasalforcingsMeltingRateEnum:           scale=yts;break; //m/yr
-		case BasalforcingsMeltingRateCorrectionEnum: scale=yts;break; //m/yr
-		case SurfaceforcingsPrecipitationEnum:       scale=yts;break; //m/yr
-		case SurfaceforcingsMassBalanceEnum:         scale=yts;break; //m/yr
-		case SurfaceforcingsSmbPosMaxEnum:				scale=yts;break; //m/yr
-		case SurfaceforcingsSmbPosMinEnum:				scale=yts;break; //m/yr
-		case SurfaceforcingsAPosEnum:						scale=yts;break; //m/yr
-		case SurfaceforcingsBPosEnum:						scale=yts;break; //m/yr
-		case SurfaceforcingsANegEnum:						scale=yts;break; //m/yr
-		case SurfaceforcingsBNegEnum:						scale=yts;break; //m/yr
+		case HydrologyWaterVxEnum:                   scale=yts;break;     //m/yr
+		case HydrologyWaterVyEnum:                   scale=yts;break;     //m/yr
+		case VxEnum:                                 scale=yts;break;     //m/yr
+		case InversionVxObsEnum:                     scale=yts;break;     //m/yr
+		case VyEnum:                                 scale=yts;break;     //m/yr
+		case InversionVyObsEnum:                     scale=yts;break;     //m/yr
+		case VzEnum:                                 scale=yts;break;     //m/yr
+		case InversionVzObsEnum:                     scale=yts;break;     //m/yr
+		case VelEnum:                                scale=yts;break;     //m/yr
+		case InversionVelObsEnum:                    scale=yts;break;     //m/yr
+		case BalancethicknessThickeningRateEnum:     scale=yts;break;     //m/yr
+		case BasalforcingsMeltingRateEnum:           scale=yts;break;     //m/yr
+		case BasalforcingsMeltingRateCorrectionEnum: scale=yts;break;     //m/yr
+		case SurfaceforcingsPrecipitationEnum:       scale=yts;break;     //m/yr
+		case SurfaceforcingsMassBalanceEnum:         scale=yts;break;     //m/yr
+		case SurfaceforcingsSmbPosMaxEnum:				scale=yts;break;     //m/yr
+		case SurfaceforcingsSmbPosMinEnum:				scale=yts;break;     //m/yr
+		case SurfaceforcingsAPosEnum:						scale=yts;break;     //m/yr
+		case SurfaceforcingsBPosEnum:						scale=yts;break;     //m/yr
+		case SurfaceforcingsANegEnum:						scale=yts;break;     //m/yr
+		case SurfaceforcingsBNegEnum:						scale=yts;break;     //m/yr
 		case MisfitEnum:                             scale=pow(yts,2);break; //(m/yr)^2
 		case MassFluxEnum:                           scale=pow((IssmDouble)10,-12)*yts;break; // (GigaTon/year)
+		case TotalSmbEnum:                           scale=pow((IssmDouble)10,-12)*yts;break; // (GigaTon/year)
 		default: scale=1.0; break;
 	}
Index: issm/trunk/src/c/shared/Numerics/Verbosity.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/Verbosity.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Numerics/Verbosity.cpp	(revision 13395)
@@ -34,5 +34,5 @@
 void SetVerbosityLevel(int level){
 
-	if(level<0) _error2_("vebosity level should be a positive integer (user provided " << level << ")");
+	if(level<0) _error_("vebosity level should be a positive integer (user provided " << level << ")");
 
 	verbositylevel = level;
Index: issm/trunk/src/c/shared/Numerics/adolc_edf.h
===================================================================
--- issm/trunk/src/c/shared/Numerics/adolc_edf.h	(revision 13395)
+++ issm/trunk/src/c/shared/Numerics/adolc_edf.h	(revision 13395)
@@ -0,0 +1,28 @@
+/*
+ * adolc_edf.h
+ *
+ *  Created on: Jun 26, 2012
+ *      Author: utke
+ */
+
+#ifndef _ADOLC_EDF_H_
+#define _ADOLC_EDF_H_
+
+#include "../../include/include.h"
+
+#ifdef _HAVE_ADOLC_
+
+struct Adolc_edf {
+    ext_diff_fct *myEDF_for_solverx_p;
+    Adolc_edf() : myEDF_for_solverx_p(0) {}
+    inline friend std::ostream& operator << ( ostream&, const Adolc_edf& );
+};
+
+std::ostream& operator << ( std::ostream& out, const Adolc_edf& a) {
+    out << a.myEDF_for_solverx_p;
+    return out;
+}
+
+#endif
+
+#endif
Index: issm/trunk/src/c/shared/Numerics/cubic.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/cubic.cpp	(revision 13395)
+++ issm/trunk/src/c/shared/Numerics/cubic.cpp	(revision 13395)
@@ -0,0 +1,91 @@
+#include <math.h>
+#include "./numerics.h"
+
+IssmDouble CBRT(IssmDouble Z){
+
+	IssmDouble ret;
+
+	if (Z> 0.0){
+		ret = fabs(pow(fabs(Z),1./3.));
+	}
+	else if(Z< 0.0){
+		ret = - fabs(pow(fabs(Z),1./3.));
+	}
+	else{
+		ret = 0.;
+	}
+	return ret;
+}
+
+int cubic(IssmDouble a,IssmDouble b,IssmDouble c,IssmDouble d, IssmDouble x[3], int* num){
+	/* Find the real roots of linear/quadratic and cubic equations:
+	 *
+	 *   a x^3 + bx^2 + cx + d = 0
+	 *
+	 *   returns the roots in x
+	 *   num is the number of roots */
+
+	/*Some useful constants*/
+	const IssmDouble pi    = 3.1415926535897932;
+	const IssmDouble third = 1./3.;
+
+	/*Intermediaries*/
+	IssmDouble U[3],W,P,Q,delta,phi;
+
+	/* determine the degree of the polynomial */
+	if (a != 0.0){
+		//cubic problem
+		W     = b/a *third;
+		P     = pow((c/a *third - pow(W,2)),3);
+		Q     = -.5 *(2.0*pow(W,3)-(c*W-d)/a );
+		delta = pow(Q,2)+P;
+		if ( delta < 0.0 ){
+			//three real solutions!
+			//Confine the argument of coeffCOS to the interval [-1;1]!
+			phi = acos(min(1.0,max(-1.0,Q/sqrt(-P))));
+			P   = 2.0*pow((-P),(5.e-1*third));
+			for(int i=0;i<3;i++)	U[i] = P*cos((phi+2*((IssmDouble)i)*pi)*third)-W;
+			x[0] = min(U[0], min(U[1], U[2]));
+			x[1] = max(min(U[0], U[1]),max( min(U[0], U[2]), min(U[1], U[2])));
+			x[2] = max(U[0], max(U[1], U[2]));
+			*num = 3;
+		}
+		else{
+			// only one real solution!
+			delta = sqrt(delta);
+			x[0] = CBRT(Q+delta)+CBRT(Q-delta)-W;
+			*num=1;
+		}
+	}
+	else if (b != 0.0){
+		// quadratic problem
+		P     = 0.5*c/b;
+		delta = pow(P,2)-d/b;
+		if (delta > 0.0){
+			// 2 real solutions
+			x[0] = -P - sqrt(delta);
+			x[1] = -P + sqrt(delta);
+			*num = 2;
+		}
+		else{
+			// no real solution
+			*num = 0;
+		}
+	}
+	else if (c != 0.0){
+		//linear equation
+		x[0] = d/c;
+		*num = 1;
+	}
+	else{
+		//no equation
+		*num = 0;
+	}
+
+	/* perform one step of a newton iteration in order to minimize round-off errors */
+	for(int i=0;i<*num;i++){
+		x[i] = x[i] - (d+x[i]*(c+x[i]*(b+x[i]*a)))/(c+x[i]*(2.0*b+x[i]*3.0*a));
+	}
+
+	return 0;
+}
Index: issm/trunk/src/c/shared/Numerics/numerics.h
===================================================================
--- issm/trunk/src/c/shared/Numerics/numerics.h	(revision 12709)
+++ issm/trunk/src/c/shared/Numerics/numerics.h	(revision 13395)
@@ -17,17 +17,18 @@
 struct OptPars;
 
-IssmDouble min(IssmDouble a,IssmDouble b);
-IssmDouble max(IssmDouble a,IssmDouble b);
-int    min(int a,int b);
-int    max(int a,int b);
-IssmDouble OptFunc(IssmDouble scalar, OptArgs* optargs);
-void   BrentSearch(IssmDouble* psearch_scalar,IssmDouble* pJ,OptPars* optpars,IssmDouble (*f)(IssmDouble,OptArgs*), OptArgs* optargs);
-void   OptimalSearch(IssmDouble* psearch_scalar,IssmDouble* pJ,OptPars* optpars,IssmDouble (*f)(IssmDouble,OptArgs*), OptArgs* optargs);
-void   cross(IssmDouble* result,IssmDouble* vector1,IssmDouble* vector2);
-void   IsInputConverged(IssmDouble* peps, Input** new_inputs,Input** old_inputs,int num_inputs,int criterion_enum);
-void   UnitConversion(IssmDouble* values, int numvalues,int direction_enum, int type_enum);
-IssmDouble UnitConversion(IssmDouble value, int direction_enum, int type_enum);
-char*  OptionsFromAnalysis(Parameters* parameters,int analysis_type);
-void   XZvectorsToCoordinateSystem(IssmDouble* T,IssmDouble* xzvectors);
+IssmDouble  min(IssmDouble a,IssmDouble b);
+IssmDouble  max(IssmDouble a,IssmDouble b);
+int         min(int a,int b);
+int         max(int a,int b);
+IssmDouble  OptFunc(IssmDouble scalar, OptArgs *optargs);
+void        BrentSearch(IssmDouble *psearch_scalar,IssmDouble*pJ,OptPars*optpars,IssmDouble (*f)(IssmDouble,OptArgs*), OptArgs*optargs);
+void        OptimalSearch(IssmDouble *psearch_scalar,IssmDouble*pJ,OptPars*optpars,IssmDouble (*f)(IssmDouble,OptArgs*), OptArgs*optargs);
+void        cross(IssmDouble *result,IssmDouble*vector1,IssmDouble*vector2);
+void        IsInputConverged(IssmDouble *peps, Input**new_inputs,Input**old_inputs,int num_inputs,int criterion_enum);
+void        UnitConversion(IssmDouble *values, int numvalues,int direction_enum, int type_enum);
+IssmDouble  UnitConversion(IssmDouble value, int direction_enum, int type_enum);
+char       *OptionsFromAnalysis(Parameters *parameters,int analysis_type);
+void        XZvectorsToCoordinateSystem(IssmDouble *T,IssmDouble*xzvectors);
+int         cubic(IssmDouble a, IssmDouble b, IssmDouble c, IssmDouble d, double X[3], int *num);
 #ifdef _HAVE_PETSC_
 void   PetscOptionsFromAnalysis(Parameters* parameters,int analysis_type);
Index: issm/trunk/src/c/shared/String/DescriptorIndex.cpp
===================================================================
--- issm/trunk/src/c/shared/String/DescriptorIndex.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/String/DescriptorIndex.cpp	(revision 13395)
@@ -23,10 +23,10 @@
 	/*retrieve first token, separated by underscore: */
 	pch = strtok (descriptor,"_");
-	if(!pch)_error2_("descriptor " << descriptor << " is not correctly formatted!");
+	if(!pch)_error_("descriptor " << descriptor << " is not correctly formatted!");
 
 	if (strncmp(pch,"scaled",6)==0){
 		/*we have a scaled variable. recover the root: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error2_("scaled descriptor " << descriptor << " is not correctly formatted!");
+		if(!pch)_error_("scaled descriptor " << descriptor << " is not correctly formatted!");
 		memcpy(root,pch,(strlen(pch)+1)*sizeof(char));
 
@@ -44,9 +44,9 @@
 		/*we have an indexed variable. recover the root: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error2_("indexed descriptor " << descriptor << " is not correctly formatted!");
+		if(!pch)_error_("indexed descriptor " << descriptor << " is not correctly formatted!");
 		memcpy(root,pch,(strlen(pch)+1)*sizeof(char));
 		/*now recover  the index: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error2_("indexed descriptor " << descriptor << " is not correctly formatted!");
+		if(!pch)_error_("indexed descriptor " << descriptor << " is not correctly formatted!");
 		sscanf(pch,"%i",pindex);
 		return IndexedEnum;
@@ -55,9 +55,9 @@
 		/*we have an indexed variable. recover the root: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error2_("nodal descriptor " << descriptor << " is not correctly formatted!");
+		if(!pch)_error_("nodal descriptor " << descriptor << " is not correctly formatted!");
 		memcpy(root,pch,(strlen(pch)+1)*sizeof(char));
 		/*now recover  the index: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error2_("nodal descriptor " << descriptor << " is not correctly formatted!");
+		if(!pch)_error_("nodal descriptor " << descriptor << " is not correctly formatted!");
 		sscanf(pch,"%i",pindex);
 		return NodalEnum;
Index: issm/trunk/src/c/shared/Sys/ProfilingStart.cpp
===================================================================
--- issm/trunk/src/c/shared/Sys/ProfilingStart.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Sys/ProfilingStart.cpp	(revision 13395)
@@ -12,4 +12,5 @@
 #include "../../include/macros.h"
 #include "../shared.h"
+#include "../../io/io.h"
 /*}}}*/
 
Index: issm/trunk/src/c/shared/Threads/LaunchThread.cpp
===================================================================
--- issm/trunk/src/c/shared/Threads/LaunchThread.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Threads/LaunchThread.cpp	(revision 13395)
@@ -44,10 +44,10 @@
 
 		if(pthread_create(threads+i,NULL,function,(void*)(handles+i))){
-			_error2_("pthread_create error");
+			_error_("pthread_create error");
 		}
 	}
 	for(i=0;i<num_threads;i++){
 		if(pthread_join(threads[i],(void**)&status)){
-			_error2_("pthread_join error");
+			_error_("pthread_join error");
 		}
 	}
Index: issm/trunk/src/c/shared/TriMesh/GridInsideHole.cpp
===================================================================
--- issm/trunk/src/c/shared/TriMesh/GridInsideHole.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/TriMesh/GridInsideHole.cpp	(revision 13395)
@@ -14,5 +14,5 @@
 int GridInsideHole(double* px0,double* py0,int n,double* x,double* y){
 
-	double flag;
+	double flag=0.0;
 	double xA,xB,xC,xD,xE;
 	double yA,yB,yC,yD,yE;
@@ -30,9 +30,6 @@
 	/*D and E are on each side of segment [A B], on the median line between segment [A  B], 
 	 *at an angle of 10 degree (less than the minimum 30 enforced by the quality of the mesh: */
-
-
 	xD=xC+tan(10./180.*M_PI)*(yC-yA);
 	yD=yC+tan(10./180.*M_PI)*(xA-xC);
-
 	xE=xC-tan(10./180.*M_PI)*(yC-yA);
 	yE=yC-tan(10./180.*M_PI)*(xA-xC);
@@ -40,5 +37,6 @@
 	/*Either E or D is inside profile (x,y): */
 	IsInPolySerial(&flag,&xD,&yD,1,x,y,n,2);
-	if (flag){
+	/*FIXME: used to be 'flag' and not '!flag', check*/
+	if(!flag){
 		/*D is inside the poly: */
 		*px0=xD;
Index: issm/trunk/src/c/shared/TriMesh/SplitMeshForRifts.cpp
===================================================================
--- issm/trunk/src/c/shared/TriMesh/SplitMeshForRifts.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/TriMesh/SplitMeshForRifts.cpp	(revision 13395)
@@ -76,12 +76,13 @@
 				 instances of node in the triangulation *for those elements, to the
 				 new node.*/
-				
+
+				//create new node
+				x=xReNew<double>(x,nods,nods+1);
+				y=xReNew<double>(y,nods,nods+1);
+				x[nods]=x[node-1]; //matlab indexing
+				y[nods]=y[node-1]; //matlab indexing
+
 				//augment number of nodes 
-				nods=nods+1;
-				//create new node
-				x=(double*)xrealloc(x,nods*sizeof(double));
-				y=(double*)xrealloc(y,nods*sizeof(double));
-				x[nods-1]=x[node-1]; //matlab indexing
-				y[nods-1]=y[node-1]; //matlab indexing
+				nods++;
 
 				//change elements owning this node
Index: issm/trunk/src/c/shared/TriMesh/TriMeshUtils.cpp
===================================================================
--- issm/trunk/src/c/shared/TriMesh/TriMeshUtils.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/TriMesh/TriMeshUtils.cpp	(revision 13395)
@@ -255,16 +255,16 @@
 	int el1,el2;
 
-	double* segments=NULL;
-	double*    segmentmarkerlist=NULL;
+	double *segments          = NULL;
+	double *segmentmarkerlist = NULL;
 	int     nsegs;
 
 	/*Recover input: */
-	segments=*psegments;
-	segmentmarkerlist=*psegmentmarkerlist;
-	nsegs=*pnsegs;
+	segments          = *psegments;
+	segmentmarkerlist = *psegmentmarkerlist;
+	nsegs             = *pnsegs;
 
 	/*Reallocate segments: */
-	segments=(double*)xrealloc(segments,(nsegs+nriftsegs)*3*sizeof(double));
-	segmentmarkerlist=(double*)xrealloc(segmentmarkerlist,(nsegs+nriftsegs)*sizeof(double));
+	segments         =xReNew<double>(segments,         nsegs*3,(nsegs+nriftsegs)*3);
+	segmentmarkerlist=xReNew<double>(segmentmarkerlist,nsegs*3,(nsegs+nriftsegs)*3);
 
 	/*First, update the existing segments to the new nodes :*/
@@ -662,6 +662,6 @@
 
 	/*Reallocate x and y: */
-	xreal=(double*)xrealloc(x,newnods*sizeof(double));
-	yreal=(double*)xrealloc(y,newnods*sizeof(double));
+	xreal=xReNew<double>(x,nods,newnods);
+	yreal=xReNew<double>(y,nods,newnods);
 	counter1=0;
 	counter2=0;
@@ -1093,10 +1093,9 @@
 				if(triple==1){
 					/*el is a corner element: we need to split it in 3 triangles: */
-					x=(double*)xrealloc(x,(nods+1)*sizeof(double));
-					y=(double*)xrealloc(y,(nods+1)*sizeof(double));
+					x=xReNew<double>(x,nods,nods+1);
+					y=xReNew<double>(y,nods,nods+1);
 					x[nods]=(x[(int)node1-1]+x[(int)node2-1]+x[(int)node3-1])/3;
 					y[nods]=(y[(int)node1-1]+y[(int)node2-1]+y[(int)node3-1])/3;
-
-					index=(double*)xrealloc(index,(nel+2)*3*sizeof(double));
+					index=xReNew<double>(index,nel*3,(nel+2*3));
 					/*First, reassign element el: */
 					*(index+3*el+0)=node1;
Index: issm/trunk/src/c/shared/Wrapper/wrappershared.h
===================================================================
--- issm/trunk/src/c/shared/Wrapper/wrappershared.h	(revision 12709)
+++ issm/trunk/src/c/shared/Wrapper/wrappershared.h	(revision 13395)
@@ -6,5 +6,5 @@
 #define _WRAPPER_SHARED_H_
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 int ModuleBoot(void);
Index: issm/trunk/src/c/shared/shared.h
===================================================================
--- issm/trunk/src/c/shared/shared.h	(revision 12709)
+++ issm/trunk/src/c/shared/shared.h	(revision 13395)
@@ -7,5 +7,4 @@
 
 #include "Alloc/alloc.h"
-#include "Alloc/alloc_module.h"
 #include "Alloc/xNewDelete.h"
 #include "Bamg/shared.h"
Index: issm/trunk/src/c/solutions/AdjointCorePointerFromSolutionEnum.cpp
===================================================================
--- issm/trunk/src/c/solutions/AdjointCorePointerFromSolutionEnum.cpp	(revision 12709)
+++ issm/trunk/src/c/solutions/AdjointCorePointerFromSolutionEnum.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -35,5 +35,5 @@
 			break;
 		default:
-			_error2_("No adjoint has been implemented for solution " << EnumToStringx(solutiontype) << " yet");
+			_error_("No adjoint has been implemented for solution " << EnumToStringx(solutiontype) << " yet");
 			break;
 	}
Index: issm/trunk/src/c/solutions/AnalysisConfiguration.cpp
===================================================================
--- issm/trunk/src/c/solutions/AnalysisConfiguration.cpp	(revision 12709)
+++ issm/trunk/src/c/solutions/AnalysisConfiguration.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -110,5 +110,5 @@
 		
 		default:
-			_error2_("solution type: " << EnumToStringx(solutiontype) << " not supported yet!");
+			_error_("solution type: " << EnumToStringx(solutiontype) << " not supported yet!");
 			break;
 	}
Index: issm/trunk/src/c/solutions/CorePointerFromSolutionEnum.cpp
===================================================================
--- issm/trunk/src/c/solutions/CorePointerFromSolutionEnum.cpp	(revision 12709)
+++ issm/trunk/src/c/solutions/CorePointerFromSolutionEnum.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -29,5 +29,5 @@
 			solutioncore=&diagnostic_core;
 			#else
-			_error2_("ISSM was not compiled with diagnostic capabilities. Exiting");
+			_error_("ISSM was not compiled with diagnostic capabilities. Exiting");
 			#endif
 			break;
@@ -36,5 +36,5 @@
 			solutioncore=&steadystate_core;
 			#else
-			_error2_("ISSM was not compiled with steady state capabilities. Exiting");
+			_error_("ISSM was not compiled with steady state capabilities. Exiting");
 			#endif
 			break;
@@ -43,5 +43,5 @@
 			solutioncore=&thermal_core;
 			#else
-			_error2_("ISSM was not compiled with thermal capabilities. Exiting");
+			_error_("ISSM was not compiled with thermal capabilities. Exiting");
 			#endif
 			break;
@@ -50,5 +50,5 @@
 			solutioncore=&enthalpy_core;
 			#else
-			_error2_("ISSM was not compiled with thermal capabilities. Exiting");
+			_error_("ISSM was not compiled with thermal capabilities. Exiting");
 			#endif
 			break;
@@ -57,5 +57,5 @@
 			solutioncore=&balancethickness_core;
 			#else
-			_error2_("ISSM was not compiled with balanced capabilities. Exiting");
+			_error_("ISSM was not compiled with balanced capabilities. Exiting");
 			#endif
 			break;
@@ -64,5 +64,5 @@
 			solutioncore=&hydrology_core;
 			#else
-			_error2_("ISSM was not compiled with hydrology capabilities. Exiting");
+			_error_("ISSM was not compiled with hydrology capabilities. Exiting");
 			#endif
 			break;
@@ -71,5 +71,5 @@
 			solutioncore=&surfaceslope_core;
 			#else
-			_error2_("ISSM was not compiled with slope capabilities. Exiting");
+			_error_("ISSM was not compiled with slope capabilities. Exiting");
 			#endif
 			break;
@@ -78,5 +78,5 @@
 			solutioncore=&bedslope_core;
 			#else
-			_error2_("ISSM was not compiled with slope capabilities. Exiting");
+			_error_("ISSM was not compiled with slope capabilities. Exiting");
 			#endif
 			break;
@@ -85,5 +85,5 @@
 			solutioncore=&transient_core;
 			#else
-			_error2_("ISSM was not compiled with transient capabilities. Exiting");
+			_error_("ISSM was not compiled with transient capabilities. Exiting");
 			#endif
 			break;
@@ -92,9 +92,9 @@
 			solutioncore=&prognostic_core;
 			#else
-			_error2_("ISSM was not compiled with prognostic capabilities. Exiting");
+			_error_("ISSM was not compiled with prognostic capabilities. Exiting");
 			#endif
 			break;
 		default:
-			_error2_("solution type: " << EnumToStringx(solutiontype) << " not supported yet!");
+			_error_("solution type: " << EnumToStringx(solutiontype) << " not supported yet!");
 			break;
 	}
Index: issm/trunk/src/c/solutions/ProcessArguments.cpp
===================================================================
--- issm/trunk/src/c/solutions/ProcessArguments.cpp	(revision 12709)
+++ issm/trunk/src/c/solutions/ProcessArguments.cpp	(revision 13395)
@@ -9,5 +9,5 @@
 #include "../include/include.h"
 
-void ProcessArguments(int* solution_type,char** pbinfilename,char** poutbinfilename,char** ppetscfilename,char** plockfilename,int argc,char **argv){
+void ProcessArguments(int* solution_type,char** pbinfilename,char** poutbinfilename,char** ppetscfilename,char** plockfilename,char** prootpath, int argc,char **argv){
 
 	char *modelname      = NULL;
@@ -16,13 +16,33 @@
 	char *petscfilename  = NULL;
 	char *lockfilename   = NULL;
+	char *rootpath       = NULL;
+	char *rootpatharg    = NULL;
 
-	if(argc<2)_error2_("Usage error: no solution requested");
 	*solution_type=StringToEnumx(argv[1]);
-	if(argc<3)_error2_("Usage error: missing model name");
+	if(argc<2)_error_("Usage error: no solution requested");
+	if(argc<3)_error_("Usage error: missing execution directory");
+	if(argc<4)_error_("Usage error: missing model name");
+
+	rootpatharg=argv[2];
+	if(strcmp(strstr(rootpatharg,"/"),"/")!=0){ 
+		rootpath       = xNew<char>(strlen(rootpatharg)+2); sprintf(rootpath,"%s/",rootpatharg);
+	}
+	else{
+		rootpath       = xNew<char>(strlen(rootpatharg)+1); sprintf(rootpath,"%s",rootpatharg);
+	}
+
 	modelname=argv[3];
-	binfilename    = xNew<char>(strlen(modelname)+strlen(".bin")   +1); sprintf(binfilename,   "%s%s",modelname,".bin");
-	outbinfilename = xNew<char>(strlen(modelname)+strlen(".outbin")+1); sprintf(outbinfilename,"%s%s",modelname,".outbin");
-	petscfilename  = xNew<char>(strlen(modelname)+strlen(".petsc") +1); sprintf(petscfilename, "%s%s",modelname,".petsc");
-	lockfilename   = xNew<char>(strlen(modelname)+strlen(".lock")  +1); sprintf(lockfilename,  "%s%s",modelname,".lock");
+	if(strstr(modelname,rootpath)==NULL){
+		binfilename    = xNew<char>(strlen(rootpath)+strlen(modelname)+strlen(".bin")   +1); sprintf(binfilename,   "%s%s%s",rootpath,modelname,".bin");
+		outbinfilename = xNew<char>(strlen(rootpath)+strlen(modelname)+strlen(".outbin")+1); sprintf(outbinfilename,"%s%s%s",rootpath,modelname,".outbin");
+		petscfilename  = xNew<char>(strlen(rootpath)+strlen(modelname)+strlen(".petsc") +1); sprintf(petscfilename, "%s%s%s",rootpath,modelname,".petsc");
+		lockfilename   = xNew<char>(strlen(rootpath)+strlen(modelname)+strlen(".lock")  +1); sprintf(lockfilename,  "%s%s%s",rootpath,modelname,".lock");
+	}
+	else{
+		binfilename    = xNew<char>(strlen(modelname)+strlen(".bin")   +1); sprintf(binfilename,   "%s%s",modelname,".bin");
+		outbinfilename = xNew<char>(strlen(modelname)+strlen(".outbin")+1); sprintf(outbinfilename,"%s%s",modelname,".outbin");
+		petscfilename  = xNew<char>(strlen(modelname)+strlen(".petsc") +1); sprintf(petscfilename, "%s%s",modelname,".petsc");
+		lockfilename   = xNew<char>(strlen(modelname)+strlen(".lock")  +1); sprintf(lockfilename,  "%s%s",modelname,".lock");
+	}
 
 	/*Clean up and assign output pointer*/
@@ -31,3 +51,5 @@
 	*ppetscfilename=petscfilename;
 	*plockfilename=lockfilename;
+	*prootpath=rootpath;
+
 }
Index: issm/trunk/src/c/solutions/ResetBoundaryConditions.cpp
===================================================================
--- issm/trunk/src/c/solutions/ResetBoundaryConditions.cpp	(revision 12709)
+++ issm/trunk/src/c/solutions/ResetBoundaryConditions.cpp	(revision 13395)
@@ -3,5 +3,5 @@
  */ 
 
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../modules/modules.h"
 #include "../io/io.h"
@@ -11,5 +11,5 @@
 	
 	/*variables: */
-	Vector*    yg    = NULL;
+	Vector<IssmDouble>*    yg    = NULL;
 	Nodes *nodes = NULL;
 	int    i;
Index: issm/trunk/src/c/solutions/WriteLockFile.cpp
===================================================================
--- issm/trunk/src/c/solutions/WriteLockFile.cpp	(revision 12709)
+++ issm/trunk/src/c/solutions/WriteLockFile.cpp	(revision 13395)
@@ -17,8 +17,8 @@
 	if(my_rank==0){
 		fid=fopen(filename,"w");
-		if(fid==NULL) _error2_("error message: could not open lock file " << filename);
+		if(fid==NULL) _error_("error message: could not open lock file " << filename);
 
 		/*Close file: */
-		if(fclose(fid)!=0) _error2_("could not close lock file " << filename);
+		if(fclose(fid)!=0) _error_("could not close lock file " << filename);
 	}
 
Index: issm/trunk/src/c/solutions/adjointbalancethickness_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/adjointbalancethickness_core.cpp	(revision 12709)
+++ issm/trunk/src/c/solutions/adjointbalancethickness_core.cpp	(revision 13395)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
Index: issm/trunk/src/c/solutions/adjointdiagnostic_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/adjointdiagnostic_core.cpp	(revision 12709)
+++ issm/trunk/src/c/solutions/adjointdiagnostic_core.cpp	(revision 13395)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
Index: issm/trunk/src/c/solutions/balancethickness_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancethickness_core.cpp	(revision 12709)
+++ issm/trunk/src/c/solutions/balancethickness_core.cpp	(revision 13395)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../io/io.h"
